## libwfa2 2.3.2

=== CMakeLists.txt ===
# For Debian currently with
#
#   cd build
#   cmake -DCMAKE_BUILD_TYPE=RelWithDebInfo ..
#   make
#   make test
#   make install
# See below option statements and the README for build information

cmake_minimum_required(VERSION 3.16)
project(wfa2lib)

set(CMAKE_CXX_STANDARD 17)

include(FeatureSummary)
include(GNUInstallDirs)

find_package(PkgConfig REQUIRED)

feature_summary(
  FATAL_ON_MISSING_REQUIRED_PACKAGES
  WHAT REQUIRED_PACKAGES_NOT_FOUND)

# ---- Options

option(OPENMP "Enable OpenMP" OFF) # enables WFA_PARALLEL
option(PROFILING "Enable profiling" OFF)
option(ASAN "Use address sanitiser" OFF)
option(EXTRA_FLAGS "Add optimization flags for C/C++ compiler" OFF)

# include(CheckIPOSupported) # adds lto
# check_ipo_supported(RESULT ipo_supported OUTPUT output)

# ---- Dependencies

if(OPENMP)
  include(FindOpenMP)
  set(OPTIMIZE_FLAGS "-DWFA_PARALLEL")
endif(OPENMP)

if(EXTRA_FLAGS)
  set(OPTIMIZE_FLAGS "${OPTIMIZE_FLAGS} ${EXTRA_FLAGS}")
endif(EXTRA_FLAGS)

find_package(Threads)
set_package_properties(Threads PROPERTIES TYPE REQUIRED)

# ---- Build switches
set(CMAKE_POSITION_INDEPENDENT_CODE ON)
# set(CMAKE_INTERPROCEDURAL_OPTIMIZATION ${ipo_supported})

if(NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE Release CACHE STRING
          "Choose the type of build, options are: Release|Debug|RelWithDebInfo (for distros)." FORCE)
endif()

if (${CMAKE_BUILD_TYPE} MATCHES Release)
  set(OPTIMIZE_FLAGS "${OPTIMIZE_FLAGS} -march=native -D_FILE_OFFSET_BITS=64")
endif()

if ((${CMAKE_BUILD_TYPE} MATCHES Release) OR (${CMAKE_BUILD_TYPE} MATCHES RelWithDebInfo))
  SET(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${OpenMP_C_FLAGS} ${OPTIMIZE_FLAGS}")
  SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OpenMP_CXX_FLAGS} ${OPTIMIZE_FLAGS}")
endif ()

if (${CMAKE_BUILD_TYPE} MATCHES "Debug")
  set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${OPTIMIZE_FLAGS}")
  set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${OPTIMIZE_FLAGS}")
  add_definitions(-Wfatal-errors)
endif ()

if (ASAN)
  set (CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fsanitize=address  -fno-omit-frame-pointer -fno-common")
  set (CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fsanitize=address  -fno-omit-frame-pointer -fno-common")
endif(ASAN)

if(PROFILING)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -g")
endif(PROFILING)

if(GPROF)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -pg")
endif(GPROF)

# ---- Include files

include_directories(wavefront)
include_directories(utils)
include_directories(.)

file(GLOB INCLUDES
  wavefront/*.h*
  )
file(GLOB UTILS_INCLUDES
  utils/*.h*
  )
file(GLOB ALIGNMENT_INCLUDES
  alignment/*.h*
  )
file(GLOB SYSTEM_INCLUDES
  system/*.h*
  )

set(wfa2lib_SOURCE
  wavefront/wavefront_align.c
  wavefront/wavefront_aligner.c
  wavefront/wavefront_attributes.c
  wavefront/wavefront_backtrace_buffer.c
  wavefront/wavefront_backtrace.c
  wavefront/wavefront_backtrace_offload.c
  wavefront/wavefront_bialign.c
  wavefront/wavefront_bialigner.c
  wavefront/wavefront.c
  wavefront/wavefront_components.c
  wavefront/wavefront_compute_affine2p.c
  wavefront/wavefront_compute_affine.c
  wavefront/wavefront_compute.c
  wavefront/wavefront_compute_edit.c
  wavefront/wavefront_compute_linear.c
  wavefront/wavefront_debug.c
  wavefront/wavefront_display.c
  wavefront/wavefront_extend.c
  wavefront/wavefront_heuristic.c
  wavefront/wavefront_pcigar.c
  wavefront/wavefront_penalties.c
  wavefront/wavefront_plot.c
  wavefront/wavefront_slab.c
  wavefront/wavefront_unialign.c
  system/mm_stack.c
  system/mm_allocator.c
  system/profiler_counter.c
  system/profiler_timer.c
  utils/bitmap.c
  utils/dna_text.c
  utils/sequence_buffer.c
  utils/vector.c
  utils/commons.c
  utils/heatmap.c
  utils/string_padded.c
  alignment/affine2p_penalties.c
  alignment/affine_penalties.c
  alignment/cigar.c
  alignment/score_matrix.c
)

add_library(wfa2_static
    ${wfa2lib_SOURCE}
    )
add_library(wfa2 SHARED ${wfa2lib_SOURCE})
set_target_properties(wfa2_static PROPERTIES OUTPUT_NAME wfa2)
set_target_properties(wfa2 PROPERTIES SOVERSION 0)


# ---- Get version

file (STRINGS "VERSION" BUILD_NUMBER)
add_definitions(-DWFA2LIB_VERSION="${BUILD_NUMBER}")
add_definitions(-DVERSION="${BUILD_NUMBER}")

set(wfa2lib_LIBS
)

# add_dependencies(wfa2lib ${wfa2lib_DEPS})

# ---- Build all

# ---- Test

enable_testing()


function(add_wfa_test)
  add_test(
    NAME wfa2lib
    COMMAND ./tests/wfa.utest.sh
    WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
    )
endfunction()

add_wfa_test()

# ---- Install

install(TARGETS wfa2_static ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR} )
install(TARGETS wfa2 ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR} )

install(FILES ${INCLUDES} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/wfa2lib/wavefront)
install(FILES ${UTILS_INCLUDES} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/wfa2lib/utils)
install(FILES ${ALIGNMENT_INCLUDES} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/wfa2lib/alignment)
install(FILES ${SYSTEM_INCLUDES} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/wfa2lib/system)

=== debian/changelog ===
libwfa2 (2.3.2-1) unstable; urgency=medium

  * New upstream version

 -- Andreas Tille <tille@debian.org>  Sat, 04 Feb 2023 09:14:13 +0100

libwfa2 (2.3.1-2) unstable; urgency=medium

  * Source-only upload

 -- Andreas Tille <tille@debian.org>  Sat, 04 Feb 2023 07:21:31 +0100

libwfa2 (2.3.1-1) unstable; urgency=medium

  * Initial release (Closes: #1029719)

 -- Andreas Tille <tille@debian.org>  Thu, 26 Jan 2023 19:45:55 +0100

=== debian/control ===
Source: libwfa2
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Andreas Tille <tille@debian.org>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               d-shlibs,
               cmake,
               pkg-config
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/med-team/libwfa2
Vcs-Git: https://salsa.debian.org/med-team/libwfa2.git
Homepage: https://github.com/smarco/WFA2-lib
Rules-Requires-Root: no

Package: libwfa2-0
Architecture: any
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: exact gap-affine algorithm (shared library)
 The wavefront alignment (WFA) algorithm is an exact gap-affine algorithm
 that takes advantage of homologous regions between the sequences to
 accelerate the alignment process. Unlike to traditional dynamic
 programming algorithms that run in quadratic time, the WFA runs in time
 O(ns+s^2), proportional to the sequence length n and the alignment score
 s, using O(s^2) memory (or O(s) using the ultralow/BiWFA mode).
 Moreover, the WFA algorithm exhibits simple computational patterns that
 the modern compilers can automatically vectorize for different
 architectures without adapting the code. To intuitively illustrate why
 the WFA algorithm is so interesting, look at the following figure. The
 left panel shows the cells computed by a classical dynamic programming
 based algorithm (like Smith-Waterman or Needleman Wunsch). In contrast,
 the right panel shows the cells computed by the WFA algorithm to obtain
 the same result (i.e., the optimal alignment).

Package: libwfa2-dev
Architecture: any
Section: libdevel
Depends: libwfa2-0 (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Description: exact gap-affine algorithm (development)
 The wavefront alignment (WFA) algorithm is an exact gap-affine algorithm
 that takes advantage of homologous regions between the sequences to
 accelerate the alignment process. Unlike to traditional dynamic
 programming algorithms that run in quadratic time, the WFA runs in time
 O(ns+s^2), proportional to the sequence length n and the alignment score
 s, using O(s^2) memory (or O(s) using the ultralow/BiWFA mode).
 Moreover, the WFA algorithm exhibits simple computational patterns that
 the modern compilers can automatically vectorize for different
 architectures without adapting the code. To intuitively illustrate why
 the WFA algorithm is so interesting, look at the following figure. The
 left panel shows the cells computed by a classical dynamic programming
 based algorithm (like Smith-Waterman or Needleman Wunsch). In contrast,
 the right panel shows the cells computed by the WFA algorithm to obtain
 the same result (i.e., the optimal alignment).
 .
 This package contains the static library and the header files.

## libwfa2 2.3.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -83,10 +83,6 @@
 endif(GPROF)
 
 # ---- Include files
-
-include_directories(wavefront)
-include_directories(utils)
-include_directories(.)
 
 file(GLOB INCLUDES
   wavefront/*.h*
@@ -149,7 +145,27 @@
 add_library(wfa2 SHARED ${wfa2lib_SOURCE})
 set_target_properties(wfa2_static PROPERTIES OUTPUT_NAME wfa2)
 set_target_properties(wfa2 PROPERTIES SOVERSION 0)
-
+target_include_directories(wfa2 PUBLIC . wavefront utils)
+target_include_directories(wfa2_static PUBLIC . wavefront utils)
+add_library(wfa2::wfa2 ALIAS wfa2)
+add_library(wfa2::wfa2_static ALIAS wfa2_static)
+
+# ---- C++ binding library
+
+set(wfa2cpp_SOURCE
+  bindings/cpp/WFAligner.cpp
+)
+file(GLOB CPP_INCLUDES
+  bindings/cpp/*.h*
+  )
+add_library(wfa2cpp_static STATIC ${wfa2cpp_SOURCE})
+add_library(wfa2cpp SHARED ${wfa2cpp_SOURCE})
+set_target_properties(wfa2cpp PROPERTIES SOVERSION 0)
+set_target_properties(wfa2cpp_static PROPERTIES OUTPUT_NAME wfa2cpp)
+target_link_libraries(wfa2cpp PUBLIC wfa2)
+target_link_libraries(wfa2cpp_static PUBLIC wfa2)
+add_library(wfa2::wfa2cpp ALIAS wfa2cpp)
+add_library(wfa2::wfa2cpp_static ALIAS wfa2cpp_static)
 
 # ---- Get version
 
@@ -181,10 +197,17 @@
 
 # ---- Install
 
-install(TARGETS wfa2_static ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR} )
-install(TARGETS wfa2 ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR} )
-
-install(FILES ${INCLUDES} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/wfa2lib/wavefront)
-install(FILES ${UTILS_INCLUDES} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/wfa2lib/utils)
-install(FILES ${ALIGNMENT_INCLUDES} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/wfa2lib/alignment)
-install(FILES ${SYSTEM_INCLUDES} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/wfa2lib/system)
+# Do not install anything when used with FetchContent
+if(CMAKE_CURRENT_SOURCE_DIR STREQUAL CMAKE_SOURCE_DIR)
+  install(TARGETS wfa2_static ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR} )
+  install(TARGETS wfa2 ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR} )
+
+  install(FILES ${INCLUDES} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/wfa2lib/wavefront)
+  install(FILES ${UTILS_INCLUDES} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/wfa2lib/utils)
+  install(FILES ${ALIGNMENT_INCLUDES} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/wfa2lib/alignment)
+  install(FILES ${SYSTEM_INCLUDES} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/wfa2lib/system)
+
+  install(TARGETS wfa2cpp ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})
+  install(TARGETS wfa2cpp_static ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR})
+  install(FILES ${CPP_INCLUDES} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/wfa2lib/bindings/cpp)
+endif()

=== Makefile ===
###############################################################################
# Flags & Folders
###############################################################################
FOLDER_BIN=bin
FOLDER_BUILD=build
FOLDER_BUILD_CPP=build/cpp
FOLDER_LIB=lib
FOLDER_TESTS=tests

UNAME=$(shell uname)

CC:=$(CC)
CPP:=$(CXX)

CC_FLAGS=-Wall -g

AR=ar
AR_FLAGS=-rsc

ifndef BUILD_EXAMPLES 
BUILD_EXAMPLES=1
endif
ifndef BUILD_TOOLS 
BUILD_TOOLS=1
endif
ifndef BUILD_WFA_PARALLEL
BUILD_WFA_PARALLEL=1
endif

###############################################################################
# Configuration rules
###############################################################################
LIB_WFA=$(FOLDER_LIB)/libwfa.a
LIB_WFA_CPP=$(FOLDER_LIB)/libwfacpp.a
SUBDIRS=alignment \
        bindings/cpp \
        system \
        utils \
        wavefront
ifeq ($(BUILD_TOOLS),1)        
    APPS+=tools/generate_dataset \
          tools/align_benchmark
endif
ifeq ($(BUILD_EXAMPLES),1)        
    APPS+=examples
endif

all: CC_FLAGS+=-O3 -march=native #-flto -ffat-lto-objects
all: build

debug: build

ASAN_OPT=-fsanitize=address -fsanitize=undefined -fsanitize=shift -fsanitize=alignment
ASAN_OPT+=-fsanitize=signed-integer-overflow -fsanitize=bool -fsanitize=enum
ASAN_OPT+=-fsanitize=pointer-compare -fsanitize=pointer-overflow -fsanitize=builtin

# ASAN: ASAN_OPTIONS=detect_leaks=1:symbolize=1 LSAN_OPTIONS=verbosity=2:log_threads=1
asan: CC_FLAGS+=$(ASAN_OPT) -fno-omit-frame-pointer -fno-common
asan: build

###############################################################################
# Build rules
###############################################################################
build: setup
build: $(SUBDIRS) 
build: lib_wfa 
build: $(APPS)

setup:
	@mkdir -p $(FOLDER_BIN) $(FOLDER_BUILD) $(FOLDER_BUILD_CPP) $(FOLDER_LIB)
	
lib_wfa: $(SUBDIRS)
	$(AR) $(AR_FLAGS) $(LIB_WFA) $(FOLDER_BUILD)/*.o 2> /dev/null
	$(AR) $(AR_FLAGS) $(LIB_WFA_CPP) $(FOLDER_BUILD)/*.o $(FOLDER_BUILD_CPP)/*.o 2> /dev/null

clean:
	rm -rf $(FOLDER_BIN) $(FOLDER_BUILD) $(FOLDER_LIB) 2> /dev/null
	$(MAKE) --directory=tools/align_benchmark clean
	$(MAKE) --directory=examples clean
	rm -rf $(FOLDER_TESTS)/*.alg $(FOLDER_TESTS)/*.log* 2> /dev/null
	
###############################################################################
# Subdir rule
###############################################################################
export
$(SUBDIRS):
	$(MAKE) --directory=$@ all
	
$(APPS):
	$(MAKE) --directory=$@ all

.PHONY: $(SUBDIRS) $(APPS)

=== alignment/Makefile ===
###############################################################################
# Definitions
###############################################################################
FOLDER_ROOT=..
FOLDER_BUILD=../build

###############################################################################
# Modules
###############################################################################
MODULES=affine_penalties \
        affine2p_penalties \
        cigar \
        score_matrix
        
SRCS=$(addsuffix .c, $(MODULES))
OBJS=$(addprefix $(FOLDER_BUILD)/, $(SRCS:.c=.o))

###############################################################################
# Rules
###############################################################################
all: $(OBJS)

# General building rule
$(FOLDER_BUILD)/%.o : %.c
	$(CC) $(CC_FLAGS) -I$(FOLDER_ROOT) -c $< -o $@

=== examples/Makefile ===
###############################################################################
# Definitions
###############################################################################
FOLDER_WFA=..
FOLDER_LIB=../lib
FOLDER_BIN=bin

###############################################################################
# Rules
###############################################################################
LIB_WFA=$(FOLDER_LIB)/libwfa.a
LIBS=-fopenmp -lm
        
all: setup examples_c examples_cpp
	
examples_c: *.c $(LIB_WFA)
	$(CC) $(CC_FLAGS) -L$(FOLDER_LIB) -I$(FOLDER_WFA) wfa_basic.c -o $(FOLDER_BIN)/wfa_basic -lwfa $(LIBS)
	$(CC) $(CC_FLAGS) -L$(FOLDER_LIB) -I$(FOLDER_WFA) wfa_adapt.c -o $(FOLDER_BIN)/wfa_adapt -lwfa $(LIBS)
	$(CC) $(CC_FLAGS) -L$(FOLDER_LIB) -I$(FOLDER_WFA) wfa_repeated.c -o $(FOLDER_BIN)/wfa_repeated -lwfa $(LIBS)
	
examples_cpp: *.cpp $(LIB_WFA)
	$(CPP) $(CC_FLAGS) -L$(FOLDER_LIB) -I$(FOLDER_WFA) wfa_bindings.cpp -o $(FOLDER_BIN)/wfa_bindings -lwfacpp $(LIBS)
	$(CPP) $(CC_FLAGS) -L$(FOLDER_LIB) -I$(FOLDER_WFA) wfa_lambda.cpp -o $(FOLDER_BIN)/wfa_lambda -lwfacpp $(LIBS)
	
setup:
	@mkdir -p $(FOLDER_BIN)

clean: 
	rm -rf $(FOLDER_BIN)

=== system/Makefile ===
###############################################################################
# Definitions
###############################################################################
FOLDER_ROOT=..
FOLDER_BUILD=../build

###############################################################################
# Modules
###############################################################################
MODULES=mm_allocator \
        mm_stack \
        profiler_counter \
        profiler_timer

SRCS=$(addsuffix .c, $(MODULES))
OBJS=$(addprefix $(FOLDER_BUILD)/, $(SRCS:.c=.o))

###############################################################################
# Rules
###############################################################################
all: $(OBJS)

# General building rule
$(FOLDER_BUILD)/%.o : %.c
	$(CC) $(CC_FLAGS) -I$(FOLDER_ROOT) -c $< -o $@

=== utils/Makefile ===
###############################################################################
# Definitions
###############################################################################
FOLDER_ROOT=..
FOLDER_BUILD=../build

###############################################################################
# Modules
###############################################################################
MODULES=bitmap \
        commons \
        dna_text \
        heatmap \
        sequence_buffer \
        string_padded \
        vector

SRCS=$(addsuffix .c, $(MODULES))
OBJS=$(addprefix $(FOLDER_BUILD)/, $(SRCS:.c=.o))

###############################################################################
# Rules
###############################################################################
all: $(OBJS)

# General building rule
$(FOLDER_BUILD)/%.o : %.c
	$(CC) $(CC_FLAGS) -I$(FOLDER_ROOT) -c $< -o $@

=== wavefront/Makefile ===
###############################################################################
# Definitions
###############################################################################
FOLDER_ROOT=..
FOLDER_BUILD=../build

###############################################################################
# Modules
###############################################################################
MODULES=wavefront_align \
        wavefront_aligner \
        wavefront_attributes \
        wavefront_backtrace_buffer \
        wavefront_backtrace_offload \
        wavefront_backtrace \
        wavefront_bialign \
        wavefront_bialigner \
        wavefront_components \
        wavefront_compute_affine \
        wavefront_compute_affine2p \
        wavefront_compute_edit \
        wavefront_compute_linear \
        wavefront_compute \
        wavefront_debug \
        wavefront_display \
        wavefront_extend \
        wavefront_heuristic \
        wavefront_pcigar \
        wavefront_penalties \
        wavefront_plot \
        wavefront_slab \
        wavefront_unialign \
        wavefront

SRCS=$(addsuffix .c, $(MODULES))
OBJS=$(addprefix $(FOLDER_BUILD)/, $(SRCS:.c=.o))

ifeq ($(BUILD_WFA_PARALLEL),1) 
PFLAGS=-DWFA_PARALLEL -fopenmp
endif
#CC_XFLAGS+=-fopt-info-vec-optimized

###############################################################################
# Rules
###############################################################################
all: $(OBJS)

# General building rule
$(FOLDER_BUILD)/%.o : %.c
	$(CC) $(CC_FLAGS) $(PFLAGS) -I$(FOLDER_ROOT) -c $< -o $@

=== bindings/cpp/Makefile ===
###############################################################################
# Definitions
###############################################################################
FOLDER_ROOT=../..
FOLDER_BUILD=../../build
FOLDER_BUILD_CPP=../../build/cpp

###############################################################################
# Modules
###############################################################################
MODULES=WFAligner
        
SRCS=$(addsuffix .cpp, $(MODULES))
OBJS=$(addprefix $(FOLDER_BUILD_CPP)/, $(SRCS:.cpp=.o))

###############################################################################
# Rules
###############################################################################
all: $(OBJS)

# General building rule
$(FOLDER_BUILD_CPP)/%.o : %.cpp
	$(CPP) $(CC_FLAGS) -I$(FOLDER_ROOT) -c $< -o $@

=== tools/align_benchmark/Makefile ===
###############################################################################
# Definitions
###############################################################################
FOLDER_WFA=../../..
FOLDER_ROOT=../..
FOLDER_LIB=$(FOLDER_ROOT)/lib
FOLDER_BIN=$(FOLDER_ROOT)/bin
FOLDER_BUILD=./build

ifeq ($(UNAME), Linux)
  LD_FLAGS+=-lrt 
endif

LI_FLAGS=-L$(FOLDER_LIB) -I$(FOLDER_ROOT) -I$(FOLDER_WFA) -I.
LIB_WFA=$(FOLDER_LIB)/libwfa.a
###############################################################################
# Rules
###############################################################################
SUBDIRS=benchmark \
        edit \
        gap_affine \
        gap_affine2p \
        gap_linear \
        indel
BIN=$(FOLDER_BIN)/align_benchmark
        
all: setup 
all: $(SUBDIRS)
all: OBJS+=$(FOLDER_BUILD)/*.o
all: align_benchmark

align_benchmark: */*.c */*.h align_benchmark.c $(LIB_WFA)
	$(CC) $(CC_FLAGS) $(LI_FLAGS) $(OBJS) align_benchmark_params.c align_benchmark.c -o $(BIN) $(LD_FLAGS) -lwfa -lm -fopenmp
	
setup:
	@mkdir -p $(FOLDER_BUILD)

clean: 
	rm -rf $(FOLDER_BUILD)
	
###############################################################################
# Subdir rule
###############################################################################
export
$(SUBDIRS):
	$(MAKE) --directory=$@ all
	
.PHONY: $(SUBDIRS)

=== tools/generate_dataset/Makefile ===
###############################################################################
# Rules
###############################################################################
all: generate_dataset

generate_dataset: generate_dataset.c
	$(CC) $(CC_FLAGS) generate_dataset.c -o ../../bin/generate_dataset $(LD_FLAGS) -lm

=== tools/align_benchmark/benchmark/Makefile ===
###############################################################################
# Definitions
###############################################################################
FOLDER_WFA=../../..
FOLDER_ROOT=..
FOLDER_BUILD=$(FOLDER_ROOT)/build

###############################################################################
# Modules
###############################################################################
MODULES=benchmark_check \
        benchmark_edit \
        benchmark_gap_affine \
        benchmark_gap_affine2p \
        benchmark_gap_linear \
        benchmark_indel \
        benchmark_utils
        
SRCS=$(addsuffix .c, $(MODULES))
OBJS=$(addprefix $(FOLDER_BUILD)/, $(SRCS:.c=.o))

###############################################################################
# Rules
###############################################################################
all: $(OBJS) 

# General building rule
$(FOLDER_BUILD)/%.o : %.c
	$(CC) $(CC_FLAGS) -I$(FOLDER_ROOT) -I$(FOLDER_WFA) -c $< -o $@

=== tools/align_benchmark/edit/Makefile ===
###############################################################################
# Definitions
###############################################################################
FOLDER_WFA=../../..
FOLDER_ROOT=..
FOLDER_BUILD=$(FOLDER_ROOT)/build

###############################################################################
# Modules
###############################################################################
MODULES=edit_bpm \
        edit_dp
        
SRCS=$(addsuffix .c, $(MODULES))
OBJS=$(addprefix $(FOLDER_BUILD)/, $(SRCS:.c=.o))

###############################################################################
# Rules
###############################################################################
all: $(OBJS)

# General building rule
$(FOLDER_BUILD)/%.o : %.c
	$(CC) $(CC_FLAGS) -I$(FOLDER_ROOT) -I$(FOLDER_WFA) -c $< -o $@

=== debian/changelog ===
libwfa2 (2.3.3-4) unstable; urgency=medium

  * Team upload.
  * d/clean: remove test logs to enable building package twice. Closes:
    #1045603

 -- Michael R. Crusoe <crusoe@debian.org>  Sat, 23 Mar 2024 12:54:21 +0100

libwfa2 (2.3.3-3) unstable; urgency=medium

  * Team upload.
  * d/control: restrict to 64-bit architectures to match all of the rdeps
    of this package. Undo the t64 transition, as that is no longer needed.

 -- Michael R. Crusoe <crusoe@debian.org>  Thu, 21 Mar 2024 13:16:19 +0100

libwfa2 (2.3.3-2.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062731

 -- Steve Langasek <vorlon@debian.org>  Fri, 01 Mar 2024 07:16:29 +0000

libwfa2 (2.3.3-2) unstable; urgency=medium

  * Team Upload.
  * Add patch to fix FTBFS with gcc-13 (Closes: #1037749)

 -- Nilesh Patra <nilesh@debian.org>  Sat, 15 Jul 2023 11:12:16 +0530

libwfa2 (2.3.3-1) unstable; urgency=medium

  * New upstream version
  * Add install scripts for libwfa2cpp

 -- Andreas Tille <tille@debian.org>  Sun, 26 Feb 2023 17:31:54 +0100

=== debian/control ===
--- 
+++ 
@@ -4,6 +4,7 @@
 Section: science
 Priority: optional
 Build-Depends: debhelper-compat (= 13),
+               architecture-is-64-bit,
                d-shlibs,
                cmake,
                pkg-config
@@ -14,10 +15,12 @@
 Rules-Requires-Root: no
 
 Package: libwfa2-0
+Provides: libwfa2-0t64 (= ${binary:Version})
 Architecture: any
 Section: libs
 Depends: ${shlibs:Depends},
          ${misc:Depends}
+Multi-Arch: same
 Description: exact gap-affine algorithm (shared library)
  The wavefront alignment (WFA) algorithm is an exact gap-affine algorithm
  that takes advantage of homologous regions between the sequences to

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1
export LC_ALL=C.UTF-8

include /usr/share/dpkg/default.mk

# for hardening you might like to uncomment this:
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@ --buildsystem=cmake

override_dh_install:
	dh_install
	d-shlibmove --commit \
		    --multiarch \
		    --devunversioned \
		    --exclude-la \
		    --movedev debian/tmp/usr/include usr \
		    debian/tmp/usr/lib/*/*.so
